#ifndef LIST_H_
#define LIST_H_

typedef int (*list_cmp)(const void *, const void *);

typedef struct list list;

struct list {
	list *next;

	void *data;
};


/* create a new one-directional list's element */
list *list_new(void);

/*
 * look up for an element with specified data
 * if insert not a 0, insert the element to the begin of list
 */
list *list_lookup(list **lp, list *elem, list_cmp cmp, int insert);

/* apply function to each element in a list */
void list_apply(list *lp, void (*fn)(list *, void *), void *args);

/* remove element with the specified data from the list */
void list_del(list **lp, void *data);

/* free list element */
void list_free(list **lp);

#endif

